from browser import document


def generic_list_getter():
    result = []
    for input_el in document.getElementsByClassName("list-adder-input"):
        result_candidate = {"value": input_el.value}
        if input_el.hasAttribute("data-id"):
            result_candidate.id = int(input_el.getAttribute("data-id"))
        if result_candidate.value != "":
            result.append(result_candidate)
    return result

# Formats data from inputs to name-value objects
def double_list_getter(firstParameter, secondParameter, allowEmptyField = False):
    result = []
    for row in document.getElementsByClassName("double-list-row"):
        output = {}
        output[firstParameter] = row.querySelector("." + firstParameter + "-input").value
        output[secondParameter] = row.querySelector("." + secondParameter + "-input").value
        if row.hasAttribute("data-id"):
            output.id = int(row.getAttribute("data-id"))

        if (allowEmptyField is False and '' in [output[firstParameter], output[secondParameter]]):
            continue

        if (allowEmptyField is True and all('' == value or value.isspace() for value in [output[firstParameter], output[secondParameter]])):
            continue

        result.append(output)

    return result


def label_list_getter():
    result = []
    for row in document.getElementsByClassName("label-list-row"):
        ltype = row.querySelector(".label-type")
        lvalue = row.querySelector(".label-value")
        lother = row.querySelector(".label-value-other")

        if lother is None:
            continue

        value = lother.value
        if not value:
            value = lvalue.options[lvalue.selectedIndex].text

        if not value:
            continue

        result.append((ltype.textContent, value))

    kontrastivno = document.getElementById("kontrastivno-input").checked;
    if kontrastivno:
        result.append(("razmerje", "kontrastivno"))

    return result
